#!/usr/local/bin/perl

#
# This script converts the KTHNOC domreg.txt format to the
# format used in Digger version 2.0 and later.
#
# USAGE: domreg2template.pl [FILENAME]
#
# If no filename is given, the script reads from stdin.
#
# Patrik Faltstrom, March 1996
#
# Copyright Bunyip Information Systems, 1996
#

if($#ARGV == -1) {
    $whoisinput = 'STDIN';
} else {
    $whoisinput = $ARGV[0];
    open whoisinput || die "Can not open $whoisinput: $!\n";
}


sub setoiso {
    local($foo) = @_;
    $foo =~ s/\}/\xE5/g;
    $foo =~ s/\]/\xC5/g;
    $foo =~ s/\{/\xE4/g;
    $foo =~ s/\[/\xC4/g;
    $foo =~ s/\|/\xF6/g;
    $foo =~ s/\\/\xD6/g;
#    $foo =~ s/&eacute;/\xE9/g;
#    $foo =~ s/&Eacute;/\xC9/g;
    return ($foo);
}

$whoisinput = 'STDIN';

print "% 900 DOMAIN\n\n";

while(<$whoisinput>) {
    if(/^$/) {
	$num = 0;
        foreach $record (@records) {
	    printf "%s",$string[$num];
	    print "# END\n\n";
	    $num++;
	}
	next;
    }
    if(/^domain: *([a-zA-Z0-9].*)$/) {
        $domains = $1;
	@records = $1 =~ split;
	$num = 0;
        foreach $record (@records) {
	    $handle = $record;
	    $handle =~ s/[\.-]//g;
	    $handle =~ y/a-z/A-Z/;
	    $handle = "DOMAIN$handle";
	    $string[$num] = "# FULL DOMAIN LOCAL $handle\n Internet-Domain: $record\n";
	    $num++;
	}
	next;
    }
    if(/^org: *Privatperson$/i) {
	next;
    }
    if(/^org: *([a-zA-Z0-9].*)$/i) {
        $foo = &setoiso($1);
	$num = 0;
        foreach $record (@records) {
	    $string[$num] .= " Organization-name: $foo\n";
	    $num++;
	}
	next;
    }
    if(/^address: *([a-zA-Z0-9].*)$/i) {
        $foo = &setoiso($1);
	$num = 0;
        foreach $record (@records) {
	    $string[$num] .= " Domain-Contact-Address: $foo\n";
	    $num++;
	}
	next;
    }
    if(/^phone: *([a-zA-Z0-9].*)$/i) {
	$num = 0;
        foreach $record (@records) {
	    $string[$num] .= " Domain-Contact-Phone: $1\n";
	    $num++;
	}
	next;
    }
    if(/^e-mail: *([a-zA-Z0-9].*)$/i) {
	$num = 0;
        foreach $record (@records) {
	    $string[$num] .= " Domain-Contact-Email: $1\n";
	    $num++;
	}
	next;
    }
}
