#!/usr/local/bin/perl

#
# This script converts SOIF templates to the
# format used in Digger version 2.0 and later.
#
# USAGE: soif2template.pl [FILENAME]
#
# If no filename is given, the script reads from stdin.
#
# Patrik Faltstrom, March 1996
#
# Copyright Bunyip Information Systems, 1996
#

if($#ARGV == -1) {
    $soif_input = 'STDIN';
} else {
    $soif_input = $ARGV[0];
    open soif_input || die "Can not open $soif_input: $!\n";
}

$serveroid="1.3.6.1.4.1.1375.2";
$handle="URC";
%commonwords = ();
######
# If you want to have the Keyword attribute filtered, this is
# the "kill-list", i.e. words that exists in this list will
# not be transfered from the SOIF to the Whois++ template.
######
# %commonwords = (
#		'the',1,
#		'for',1,
#		'this',1,
#		'information',1,
#		'with',1,
#		'that',1,
#		'from',1,
#		'which',1,
#		'have',1,
#		'not',1,
#		'more',1,
#		'all',1,
#		'data',1,
#		'will',1,
#		'has',1,
#		'use',1,
#		'systems',1,
#		'number',1,
#		'but',1,
#		'one',1,
#		'some',1,
#		'system',1,
#		'there',1,
#		'these',1,
#		'com',1,
#		'into',1,
#		'than',1,
#		'was',1,
#		'only',1,
#		'any',1,
#		'such',1,
#		'also',1,
#		'its',1,
#		'what',1,
#		'would',1,
#		'new',1,
#		'based',1,
#		'they',1,
#		'using',1,
#		'out',1,
#		'about',1,
#		'edu',1,
#		'may',1,
#		'name',1,
#		'should',1,
#		'their',1,
#		'two',1,
#		'internet',1,
#		'see',1,
#		'been',1,
#		'used',1,
#		'document',1,
#		'other',1,
#		'time',1,
#		'group',1,
#		'how',1,
#		'you',1,
#		'like',1,
#		'most',1,
#		'those',1,
#		'first',1,
#		'between',1,
#		'need',1,
#		'net',1,
#		'services',1,
#		'part',1,
#		'date',1,
#		'make',1,
#		'subject',1,
#		'work',1,
#		'now',1,
#		'case',1,
#		'example',1,
#		'mail',1,
#		'same',1,
#		'network',1,
#		'people',1,
#		'where',1,
#		'could',1,
#		'does',1,
#		'well',1,
#		'being',1,
#		'different',1,
#		'just',1,
#		'resource',1,
#		'support',1,
#		'then',1,
#		'get',1,
#		'list',1,
#		'many',1,
#		'documents',1,
#		'message',1,
#		'names',1,
#		'way',1,
#		'before',1,
#		'http',1,
#		'might',1,
#		'problem',1,
#		'provide',1,
#		'software',1,
#		'user',1,
#		'when',1,
#		'change',1,
#		'end',1,
#		'however',1,
#		'since',1,
#		'within',1,
#		'form',1,
#		'issues',1,
#		'must',1,
#		'problems',1,
#		'think',1,
#		'university',1,
#		'access',1,
#		'general',1,
#		'server',1,
#		'them',1,
#		'type',1,
#		'available',1,
#		'both',1,
#		'ftp',1,
#		'know',1,
#		'service',1,
#		'uri',1,
#		'very',1,
#		'your',1,
#		'don',1,
#		'url',1,
#		'www',1,
#		'note',1,
#		'possible',1,
#		'edi',1,
#		'even',1,
#		'much',1,
#		'rather',1,
#		'standard',1,
#		'want',1,
#		'were',1,
#		'draft',1,
#		'each',1,
#		'level',1,
#		'scheme',1,
#		'servers',1,
#		'without',1,
#		'working',1,
#		'another',1,
#		'content',1,
#		'following',1,
#		'here',1,
#		'through',1,
#		'version',1,
#		'able',1,
#		'domain',1,
#		'html',1,
#		'over',1,
#		'address',1,
#		'because',1,
#		'client',1,
#		'electronic',1,
#		'existing',1,
#		'issue',1,
#		'technology',1,
#		'volume',1,
#		'while',1,
#		'after',1,
#		'although',1,
#		'host',1,
#		'ietf',1,
#		'made',1,
#		'order',1,
#		'particular',1,
#		'point',1,
#		'rfc',1,
#		'send',1,
#		'syntax',1,
#		'urls',1,
#		'file',1,
#		'paul',1,
#		'research',1,
#		'users',1,
#		'wrote',1,
#		'already',1,
#		'current',1,
#		'defined',1,
#		'discussion',1,
#		'etc',1,
#		'right',1,
#		'set',1,
#		'allow',1,
#		'bunyip',1,
#		'fax',1,
#		'implementation',1,
#		'long',1,
#		'our',1,
#		'things',1,
#		'digest',1,
#		'given',1,
#		'process',1,
#		'standards',1,
#		'urn',1,
#		'author',1,
#		'comments',1,
#		'computer',1,
#		'gov',1,
#		'means',1,
#		'something',1,
#		'still',1,
#		'text',1,
#		'multiple',1,
#		'page',1,
#		'single',1,
#		'why',1,
#		'application',1,
#		'applications',1,
#		'appropriate',1,
#		'email',1,
#		'important',1,
#		'line',1,
#		'lists',1,
#		'please',1,
#		'protocol',1,
#		'response',1,
#		'results',1,
#		'say',1,
#		'allows',1,
#		'business',1,
#		'format',1,
#		'going',1,
#		'last',1,
#		'local',1,
#		'specific',1,
#		'daniel',1,
#		'good',1,
#		'method',1,
#		'schemes',1,
#		'seems',1,
#		'take',1,
#		'under',1,
#		'abstract',1,
#		'either',1,
#		'examples',1,
#		'include',1,
#		'look',1,
#		'needs',1,
#		'resources',1,
#		'second',1,
#		'section',1,
#		'several',1,
#		'better',1,
#		'context',1,
#		'doesn',1,
#		'doing',1,
#		'having',1,
#		'org',1,
#		'proposal',1,
#		'requirements',1,
#		'thus',1,
#		'urc',1,
#		'above',1,
#		'description',1,
#		'development',1,
#		'instead',1,
#		'makes',1,
#		'probably',1,
#		'structure',1,
#		'types',1,
#		'below',1,
#		'clients',1,
#		'course',1,
#		'done',1,
#		'inc',1,
#		'including',1,
#		'search',1,
#		'security',1,
#		'technical',1,
#		'uniform',1,
#		'world',1,
#		'changes',1,
#		'dns',1,
#		'object',1,
#		'own',1,
#		'really',1,
#		'space',1,
#		'spec',1,
#		'thing',1,
#		'txt',1,
#		'common',1,
#		'described',1,
#		'idea',1,
#		'international',1,
#		'least',1,
#		'let',1,
#		'major',1,
#		'paper',1,
#		'put',1,
#		'question',1,
#		'request',1,
#		'useful',1,
#		'web',1,
#		'anyone',1,
#		'far',1,
#		'introduction',1,
#		'larry',1,
#		'path',1,
#		'real',1,
#		'terms',1,
#		'too',1,
#		'add',1,
#		'cannot',1,
#		'few',1,
#		'field',1,
#		'find',1,
#		'full',1,
#		'future',1,
#		'hoffman',1,
#		'itself',1,
#		'known',1,
#		'ron',1,
#		'separate',1,
#		'specified',1,
#		'urns',1,
#		'value',1,
#		'wide',1,
#		'actually',1,
#		'body',1,
#		'currently',1,
#		'developed',1,
#		'during',1,
#		'had',1,
#		'model',1,
#		'needed',1,
#		'place',1,
#		'protocols',1,
#		'resolution',1,
#		'specification',1,
#		'term',1,
#		'top',1,
#		'approach',1,
#		'complete',1,
#		'directory',1,
#		'messages',1,
#		'next',1,
#		'project',1,
#		'provides',1,
#		'said',1,
#		'simple',1,
#		'suggest',1,
#		'sure',1,
#		'three',1,
#		'view',1,
#		'action',1,
#		'ascii',1,
#		'believe',1,
#		'database',1,
#		'drafts',1,
#		'encoding',1,
#		'handle',1,
#		'header',1,
#		'info',1,
#		'necessary',1,
#		'off',1,
#		'proper',1,
#		'query',1,
#		'required',1,
#		'understand',1,
#		'urcs',1,
#		'various',1,
#		'yet',1,
#		'added',1,
#		'every',1,
#		'give',1,
#		'masinter',1,
#		'mime',1,
#		'others',1,
#		'proposed',1,
#		'talk',1,
#		'wed',1,
#		'yes',1,
#		'additional',1,
#		'addresses',1,
#		'agree',1,
#		'code',1,
#		'considered',1,
#		'discussed',1,
#		'enough',1,
#		'great',1,
#		'internic',1,
#		'kind',1,
#		'non',1,
#		'public',1,
#		'references',1,
#		'similar',1,
#		'external',1,
#		'found',1,
#		'identifiers',1,
#		'included',1,
#		'location',1,
#		'management',1,
#		'mechanism',1,
#		'michael',1,
#		'mon',1,
#		'national',1,
#		'port',1,
#		'publishing',1,
#		'requests',1,
#		'site',1,
#		'title',1,
#		'together',1,
#		'australia',1,
#		'back',1,
#		'community',1,
#		'control',1,
#		'forms',1,
#		'further',1,
#		'isn',1,
#		'library',1,
#		'naming',1,
#		'perhaps',1,
#		'plain',1,
#		'purpose',1,
#		'read',1,
#		'return',1,
#		'sense',1,
#		'solution',1,
#		'writes',1,
#		'xerox',1,
#		'acl',1,
#		'consider',1,
#		'contain',1,
#		'little',1,
#		'provided',1,
#		'reason',1,
#		'until',1,
#		'area',1,
#		'associated',1,
#		'base',1,
#		'certainly',1,
#		'distributed',1,
#		'fact',1,
#		'fri',1,
#		'intended',1,
#		'jan',1,
#		'keep',1,
#		'machine',1,
#		'parc',1,
#		'parts',1,
#		'questions',1,
#		'require',1,
#		'requires',1,
#		'semantics',1,
#		'sent',1,
#		'someone',1,
#		'status',1,
#		'transfer',1,
#		'trying',1,
#		'usa',1,
#		'anything',1,
#		'authority',1,
#		'create',1,
#		'define',1,
#		'down',1,
#		'global',1,
#		'help',1,
#		'human',1,
#		'lanl',1,
#		'large',1,
#		'likely',1,
#		'maybe',1,
#		'quite',1,
#		'reference',1,
#		'seen',1,
#		'string',1,
#		'tue',1,
#		'among',1,
#		'appear',1,
#		'around',1,
#		'call',1,
#		'come',1,
#		'design',1,
#		'enable',1,
#		'hosts',1,
#		'making',1,
#		'material',1,
#		'mean',1,
#		'pages',1,
#		'resolve',1,
#		'run',1,
#		'specify',1,
#		'thought',1,
#		'cost',1,
#		'deal',1,
#		'did',1,
#		'didn',1,
#		'folks',1,
#		'follow',1,
#		'forward',1,
#		'internal',1,
#		'june',1,
#		'open',1,
#		'original',1,
#		'rdaniel',1,
#		'received',1,
#		'related',1,
#		'retrieval',1,
#		'special',1,
#		'thanks',1,
#		'via',1,
#		'whether',1,
#		'architecture',1,
#		'best',1,
#		'called',1,
#		'chapter',1,
#		'check',1,
#		'definition',1,
#		'department',1,
#		'directories',1,
#		'exactly',1,
#		'generic',1,
#		'integration',1,
#		'interchange',1,
#		'iso',1,
#		'language',1,
#		'less',1,
#		'methods',1,
#		'organisations',1,
#		'reasonable',1,
#		'reasons',1,
#		'result',1,
#		'small',1,
#		'strategic',1,
#		'stuff',1,
#		'upon',1,
#		'valid',1,
#		'ways',1,
#		'ability',1,
#		'again',1,
#		'against',1,
#		'bit',1,
#		'contains',1,
#		'creating',1,
#		'earlier',1,
#		'fields',1,
#		'groups',1,
#		'interface',1,
#		'looking',1,
#		'meeting',1,
#		'objects',1,
#		'owner',1,
#		'potential',1,
#		'present',1,
#		'reston',1,
#		'revised',1,
#		'rules',1,
#		'seem',1,
#		'sgml',1,
#		'sun',1,
#		'thu',1,
#		'updated',1,
#		'along',1,
#		'benefits',1,
#		'certain',1,
#		'contact',1,
#		'details',1,
#		'else',1,
#		'engineering',1,
#		'inter',1,
#		'levels',1,
#		'link',1,
#		'mentioned',1,
#		'metadata',1,
#		'months',1,
#		'once',1,
#		'optional',1,
#		'organisation',1,
#		'phone',1,
#		'program',1,
#		'relative',1,
#		'school',1,
#		'short',1,
#		'start',1,
#		'state',1,
#		'student',1,
#		'therefore',1,
#		'try',1,
#		'uses',1,
#		'year',1,
#		'ask',1,
#		'attribute',1,
#		'become',1,
#		'clear',1,
#		'cnri',1,
#		'concept',1,
#		'default',1,
#		'describe',1,
#		'elements',1,
#		'environment',1,
#		'expect',1,
#		'main',1,
#		'never',1,
#		'numbers',1,
#		'per',1,
#		'presented',1,
#		'record',1,
#		'retrieve',1,
#		'scope',1,
#		'survey',1,
#		'today',1,
#		'whole',1,
#		'works',1,
#		'alternative',1,
#		'always',1,
#		'areas',1,
#		'browsers',1,
#		'canada',1,
#		'complex',1,
#		'concerns',1,
#		'contained',1,
#		'continue',1,
#		'correct',1,
#		'describes',1,
#		'directly',1,
#		'element',1,
#		'expected',1,
#		'gateway',1,
#		'gopher',1,
#		'hope',1,
#		'identify',1,
#		'limited',1,
#		'points',1,
#		'providing',1,
#		'ronald',1,
#		'sort',1,
#		'task',1,
#		'written',1,
#		'actual',1,
#		'advantage',1,
#		'allowed',1,
#		'alpha',1,
#		'automatically',1,
#		'browser',1,
#		'center',1,
#		'company',1,
#		'domains',1,
#		'easy',1,
#		'exchange',1,
#		'getting',1,
#		'haven',1,
#		'later',1,
#		'looks',1,
#		'mailserver',1,
#		'pdt',1,
#		'precedence',1,
#		'reading',1,
#		'share',1,
#		'though',1,
#		'tools',1,
#		'transport',1,
#		'years',1,
#		'across',1,
#		'analysis',1,
#		'aren',1,
#		'capable',1,
#		'communications',1,
#		'components',1,
#		'distribution',1,
#		'due',1,
#		'early',1,
#		'except',1,
#		'exist',1,
#		'fielding',1,
#		'formats',1,
#		'got',1,
#		'hand',1,
#		'headers',1,
#		'implement',1,
#		'industry',1,
#		'interest',1,
#		'interested',1,
#		'mailing',1,
#		'mark',1,
#		'nothing',1,
#		'pointed',1,
#		'report',1,
#		'running',1,
#		'says',1,
#		'simply',1,
#		'thinking',1,
#		'true',1,
#		'accept',1,
#		'agents',1,
#		'allen',1,
#		'characters',1,
#		'class',1,
#		'codes',1,
#		'country',1,
#		'encoded',1,
#		'especially',1,
#		'est',1,
#		'his',1,
#		'instance',1,
#		'jun',1,
#		'lines',1,
#		'lot',1,
#		'matter',1,
#		'maximum',1,
#		'mechanisms',1,
#		'move',1,
#		'outside',1,
#		'pst',1,
#		'quick',1,
#		'reader',1,
#		'records',1,
#		'reply',1,
#		'representation',1,
#		'returned',1,
#		'sites',1,
#		'smtp',1,
#		'swatman',1,
#		'third',1,
#		'towards',1,
#		'variety',1,
#		'week',1,
#		'won',1,
#		'writing',1,
#		'agreement',1,
#		'aspects',1,
#		'attributes',1,
#		'basic',1,
#		'bulk',1,
#		'caching',1,
#		'cause',1,
#		'changed',1,
#		'character',1,
#		'cheers',1,
#		'clearly',1,
#		'completely',1,
#		'computing',1,
#		'easily',1,
#		'experience',1,
#		'focus',1,
#		'identifier',1,
#		'infrastructure',1,
#		'involved',1,
#		'listing',1,
#		'login',1,
#		'nic',1,
#		'oclc',1,
#		'organisational',1,
#		'overall',1,
#		'particularly',1,
#		'product',1,
#		'pub',1,
#		'roy',1,
#		'science',1,
#		'sending',1,
#		'show',1,
#		'significant',1,
#		'six',1,
#		'strategy',1,
#		'studies',1,
#		'suggestion',1,
#		'takes',1,
#		'test',1,
#		'trade',1,
#		'wanted',1,
#		'wrong',1,
#		'addressed',1,
#		'almost',1,
#		'anonymous',1,
#		'beyond',1,
#		'choice',1,
#		'comment',1,
#		'contents',1,
#		'costs',1,
#		'designed',1,
#		'determine',1,
#		'discuss',1,
#		'east',1,
#		'effective',1,
#		'entry',1,
#		'europe',1,
#		'files',1,
#		'gets',1,
#		'high',1,
#		'home',1,
#		'individual',1,
#		'item',1,
#		'length',1,
#		'links',1,
#		'machines',1,
#		'mailto',1,
#		'missing',1,
#		'networks',1,
#		'often',1,
#		'organization',1,
#		'planning',1,
#		'pretty',1,
#		'propose',1,
#		'published',1,
#		'putting',1,
#		'registered',1,
#		'replaced',1,
#		'review',1,
#		'scenarios',1,
#		'sender',1,
#		'serve',1,
#		'specifying',1,
#		'structured',1,
#		'suggested',1,
#		'tel',1,
#		'topic',1,
#		'trading',1,
#		'transaction',1,
#		'uris',1,
#		'versions',1,
#		'whatever',1,
#		'adding',1,
#		'agent',1,
#		'avoid',1,
#		'aware',1,
#		'california',1,
#		'confusing',1,
#		'formal',1,
#		'free',1,
#		'independent',1,
#		'john',1,
#		'late',1,
#		'named',1,
#		'nor',1,
#		'operations',1,
#		'possibly',1,
#		'primary',1,
#		'recent',1,
#		'regarding',1,
#		'resolving',1,
#		'scale',1,
#		'session',1,
#		'strongly',1,
#		'suggests',1,
#		'taken',1,
#		'telecommunications',1,
#		'whois',1,
#		'word',1,
#		'activities',1,
#		'answer',1,
#		'assume',1,
#		'attempts',1,
#		'authors',1,
#		'bad',1,
#		'basis',1,
#		'comes',1,
#		'companies',1,
#		'critical',1,
#		'daemon',1,
#		'databases',1,
#		'detailed',1,
#		'entire',1,
#		'everyone',1,
#		'fully',1,
#		'goes',1,
#		'growth',1,
#		'handled',1,
#		'includes',1,
#		'january',1,
#		'locators',1,
#		'mac',1,
#		'majority',1,
#		'mealling',1,
#		'meant',1,
#		'multi',1,
#		'ncsa',1,
#		'otherwise',1,
#		'plan',1,
#		'proposals',1,
#		'proxy',1,
#		'publisher',1,
#		'relevant',1,
#		'resolved',1,
#		'resolver',1,
#		'saying',1,
#		'source',1,
#		'states',1,
#		'table',1,
#		'theory',1,
#		'tried',1,
#		'write',1,
#		'addition',1,
#		'australian',1,
#		'build',1,
#		'building',1,
#		'changing',1,
#		'charset',1,
#		'collection',1,
#		'communication',1,
#		'concern',1,
#		'dan',1,
#		'difficult',1,
#		'embedded',1,
#		'ever',1,
#		'expires',1,
#		'function',1,
#		'functionality',1,
#		'implementing',1,
#		'implications',1,
#		'isi',1,
#		'locations',1,
#		'longer',1,
#		'maintain',1,
#		'market',1,
#		'media',1,
#		'nice',1,
#		'notes',1,
#		'operation',1,
#		'practice',1,
#		'sets',1,
#		'step',1,
#		'study',1,
#		'terry',1,
#		'tuesday',1,
#		'unique',1,
#		'wants',1,
#		'willing',1,
#		'worth',1,
#		'apply',1,
#		'away',1,
#		'bar',1,
#		'big',1,
#		'care',1,
#		'dtd',1,
#		'establish',1,
#		'extension',1,
#		'filename',1,
#		'finally',1,
#		'fine',1,
#		'foo',1,
#		'handling',1,
#		'hierarchical',1,
#		'identifying',1,
#		'impact',1,
#		'index',1,
#		'interesting',1,
#		'learn',1,
#		'listed',1,
#		'located',1,
#		'mailserv',1,
#		'namespace',1,
#		'none',1,
#		'organizations',1,
#		'party',1,
#		'person',1,
#		'practical',1,
#		'primarily',1,
#		'programs',1,
#		'refer',1,
#		'relationships',1,
#		'role',1,
#		'similarly',1,
#		'sorry',1,
#		'taking',1,
#		'west',1,
#		'allowing',1,
#		'appendix',1,
#		'argument',1,
#		'assigned',1,
#		'becomes',1,
#		'box',1,
#		'built',1,
#		'central',1,
#		'coming',1,
#		'conference',1,
#		'considering',1,
#		'copy',1,
#		'created',1,
#		'cross',1,
#		'defining',1,
#		'detail',1,
#		'doc',1,
#		'entity',1,
#		'features',1,
#		'feb',1,
#		'final',1,
#		'follows',1,
#		'grad',1,
#		'guess',1,
#		'hierarchy',1,
#		'initial',1,
#		'items',1,
#		'key',1,
#		'life',1,
#		'localhost',1,
#		'locator',1,
#		'mapping',1,
#		'match',1,
#		'members',1,
#		'mind',1,
#		'munnari',1,
#		'necessarily',1,
#		'networking',1,
#		'nordu',1,
#		'ora',1,
#		'places',1,
#		'play',1,
#		'prefer',1,
#		'previous',1,
#		'processing',1,
#		'publishers',1,
#		'regards',1,
#		'registration',1,
#		'relationship',1,
#		'reserved',1,
#		'revision',1,
#		'sat',1,
#		'seeing',1,
#		'side',1,
#		'size',1,
#		'starting',1,
#		'sub',1,
#		'talking',1,
#		'topics',1,
#		'translation',1,
#		'uiuc',1,
#		'writers',1,
#		'abstracts',1,
#		'accessible',1,
#		'administrative',1,
#		'agenda',1,
#		'asked',1,
#		'assuming',1,
#		'attempt',1,
#		'boundary',1,
#		'capabilities',1,
#		'cases',1,
#		'competitive',1,
#		'connection',1,
#		'couple',1,
#		'curtin',1,
#		'decide',1,
#		'decision',1,
#		'depends',1,
#		'dir',1,
#		'disagree',1,
#		'explicitly',1,
#		'extend',1,
#		'finger',1,
#		'gatech',1,
#		'generated',1,
#		'gives',1,
#		'hard',1,
#		'iana',1,
#		'implemented',1,
#		'indicate',1,
#		'leslie',1,
#		'mar',1,
#		'march',1,
#		'memo',1,
#		'meta',1,
#		'mit',1,
#		'mocha',1,
#		'montreal',1,
#		'multipart',1,
#		'myself',1,
#		'news',1,
#		'opaque',1,
#		'peter',1,
#		'policy',1,
#		'presentation',1,
#		'processes',1,
#		'remember',1,
#		'remote',1,
#		'select',1,
#		'sessions',1,
#		'shapiro',1,
#		'shouldn',1,
#		'situation',1,
#		'soon',1,
#		'suppliers',1,
#		'supported',1,
#		'tcp',1,
#		'technologies',1,
#		'tell',1,
#		'template',1,
#		'themselves',1,
#		'thesis',1,
#		'united',1,
#		'unless',1,
#		'ura',1,
#		'usage',1,
#		'username',1,
#		'values',1,
#		'widely',1,
#		'windows',1,
#		'wouldn',1,
#		'accepted',1,
#		'accessed',1,
#		'administration',1,
#		'advantages',1,
#		'american',1,
#		'ansi',1,
#		'apr',1,
#		'beginning',1,
#		'characteristics',1,
#		'close',1,
#		'commerce',1,
#		'compliant',1,
#		'day',1,
#		'days',1,
#		'december',1,
#		'dependent',1,
#		'direct',1,
#		'discusses',1,
#		'ensure',1,
#		'european',1,
#		'fred',1,
#		'government',1,
#		'greater',1,
#		'guru',1,
#		'imagine',1,
#		'importance',1,
#		'increasing',1,
#		'integrated',1,
#		'keith',1,
#		'larger',1,
#		'latest',1,
#		'left',1,
#		'literature',1,
#		'meet',1,
#		'mil',1,
#		'mitra',1,
#		'monday',1,
#		'notion',1,
#		'offer',1,
#		'ones',1,
#		'overview',1,
#		'popular',1,
#		'portion',1,
#		'purposes',1,
#		'queries',1,
#		'recently',1,
#		'requirement',1,
#		'responsible',1,
#		'scalability',1,
#		'senior',1,
#		'september',1,
#		'shadow',1,
#		'solve',1,
#		'staff',1,
#		'stockholm',1,
#		'style',1,
#		'suggestions',1,
#		'supply',1,
#		'thank',1,
#		'total',1,
#		'turn',1,
#		'valuable',1,
#		'zone',1,
#		'achieve',1,
#		'actions',1,
#		'addressing',1,
#		'africa',1,
#		'agreed',1,
#		'anyway',1,
#		'authorities',1,
#		'avron',1,
#		'behind',1,
#		'book',1,
#		'brian',1,
#		'came',1,
#		'choose',1,
#		'comparison',1,
#		'considerations',1,
#		'cover',1,
#		'criticism',1,
#		'defines',1,
#		'despite',1,
#		'destined',1,
#		'developing',1,
#		'difference',1,
#		'digital',1,
#		'discovery',1,
#		'easier',1,
#		'error',1,
#		'extended',1,
#		'extra',1,
#		'fetch',1,
#		'force',1,
#		'four',1,
#		'framework',1,
#		'functional',1,
#		'fundamental',1,
#		'higher',1,
#		'ics',1,
#		'ida',1,
#		'increase',1,
#		'july',1,
#		'knowledge',1,
#		'kunze',1,
#		'laliberte',1,
#		'load',1,
#		'mailer',1,
#		'mercury',1,
#		'modified',1,
#		'nextpart',1,
#		'old',1,
#		'otheraccess',1,
#		'pacific',1,
#		'papers',1,
#		'parsing',1,
#		'partners',1,
#		'paths',1,
#		'perspective',1,
#		'piece',1,
#		'products',1,
#		'providers',1,
#		'range',1,
#		'registry',1,
#		'researchers',1,
#		'responsibility',1,
#		'rest',1,
#		'script',1,
#		'serious',1,
#		'solutions',1,
#		'spaces',1,
#		'specifically',1,
#		'suggesting',1,
#		'times',1,
#		'track',1,
#		'uci',1,
#		'understanding',1,
#		'unix',1,
#		'voice',1,
#		'western',1,
#		'whose',1,
#		'words',1,
#		'academic',1,
#		'according',1,
#		'active',1,
#		'ago',1,
#		'amount',1,
#		'anon',1,
#		'arguments',1,
#		'associates',1,
#		'bnf',1,
#		'brief',1,
#		'british',1,
#		'chose',1,
#		'compatible',1,
#		'component',1,
#		'consideration',1,
#		'consistent',1,
#		'decided',1,
#		'depending',1,
#		'describing',1,
#		'deutsch',1,
#		'documentation',1,
#		'edifact',1,
#		'editor',1,
#		'empty',1,
#		'equivalent',1,
#		'essentially',1,
#		'exact',1,
#		'feel',1,
#		'figure',1,
#		'friday',1,
#		'ideas',1,
#		'iesg',1,
#		'int',1,
#		'interpreted',1,
#		'introduce',1,
#		'isbn',1,
#		'lower',1,
#		'mention',1,
#		'minutes',1,
#		'models',1,
#		'nature',1,
#		'normally',1,
#		'north',1,
#		'obsoleted',1,
#		'occur',1,
#		'oit',1,
#		'online',1,
#		'parse',1,
#		'period',1,
#		'plus',1,
#		'pointer',1,
#		'post',1,
#		'progress',1,
#		'projects',1,
#		'proxies',1,
#		'quality',1,
#		'quoted',1,
#		'recipient',1,
#		'reduce',1,
#		'reilly',1,
#		'replication',1,
#		'returns',1,
#		'round',1,
#		'shown',1,
#		'signature',1,
#		'stu',1,
#		'summary',1,
#		'tells',1,
#		'telnet',1,
#		'throughout',1,
#		'tree',1,
#		'trivial',1,
#		'typically',1,
#		'union',1,
#		'update',1,
#		'uras',1,
#		'activity',1,
#		'apollo',1,
#		'appreciate',1,
#		'april',1,
#		'assumed',1,
#		'break',1,
#		'capability',1,
#		'cisco',1,
#		'command',1,
#		'computers',1,
#		'concerned',1,
#		'confusion',1,
#		'convinced',1,
#		'countries',1,
#		'daigle',1,
#		'david',1,
#		'deleted',1,
#		'dirk',1,
#		'discussions',1,
#		'earth',1,
#		'edt',1,
#		'effect',1,
#		'efficiency',1,
#		'encode',1,
#		'entirely',1,
#		'everything',1,
#		'fairly',1,
#		'happens',1,
#		'happy',1,
#		'identification',1,
#		'implementors',1,
#		'inappropriate',1,
#		'indeed',1,
#		'initially',1,
#		'initiative',1,
#		'interpret',1,
#		'irvine',1,
#		'jupiter',1,
#		'legal',1,
#		'lots',1,
#		'manner',1,
#		'map',1,
#		'meaning',1,
#		'mosaic',1,
#		'moving',1,
#		'office',1,
#		'option',1,
#		'orion',1,
#		'parent',1,
#		'parties',1,
#		'past',1,
#		'paula',1,
#		'potentially',1,
#		'prefix',1,
#		'prepare',1,
#		'prepared',1,
#		'previously',1,
#		'provider',1,
#		'publication',1,
#		'rapid',1,
#		'readable',1,
#		'release',1,
#		'requested',1,
#		'requiring',1,
#		'scalable',1,
#		'scenario',1,
#		'scripts',1,
#		'searching',1,
#		'selection',1,
#		'sounds',1,
#		'south',1,
#		'specifies',1,
#		'split',1,
#		'strings',1,
#		'structures',1,
#		'successful',1,
#		'sufficient',1,
#		'suitable',1,
#		'target',1,
#		'traditional',1,
#		'weibel',1,
#		'wish',1,
#		'workshop',1,
#		'america',1,
#		'appears',1,
#		'applied',1,
#		'approval',1,
#		'assignment',1,
#		'attention',1,
#		'basically',1,
#		'beethoven',1,
#		'benefit',1,
#		'bhp',1,
#		'bin',1,
#		'boundaries',1,
#		'careful',1,
#		'coast',1,
#		'concepts',1,
#		'congress',1,
#		'core',1,
#		'corporate',1,
#		'correctly',1,
#		'corresponding',1,
#		'davenport',1,
#		'dealing',1,
#		'dec',1,
#		'definitions',1,
#		'demand',1,
#		'discover',1,
#		'distinction',1,
#		'dynamic',1,
#		'eagle',1,
#		'elsewhere',1,
#		'explicit',1,
#		'extent',1,
#		'fashion',1,
#		'february',1,
#		'five',1,
#		'fix',1,
#		'flat',1,
#		'focused',1,
#		'functions',1,
#		'hack',1,
#		'happen',1,
#		'hermes',1,
#		'hex',1,
#		'house',1,
#		'input',1,
#		'integrating',1,
#		'kidcode',1,
#		'leave',1,
#		'loc',1,
#		'marc',1,
#		'measure',1,
#		'merely',1,
#		'merlin',1,
#		'moved',1,
#		'near',1,
#		'newton',1,
#		'oct',1,
#		'onto',1,
#		'opportunities',1,
#		'oriented',1,
#		'parameters',1,
#		'parsed',1,
#		'parser',1,
#		'payment',1,
#		'perform',1,
#		'persistence',1,
#		'personal',1,
#		'personally',1,
#		'price',1,
#		'private',1,
#		'receive',1,
#		'redesign',1,
#		'replace',1,
#		'replicated',1,
#		'represent',1,
#		'responses',1,
#		'rim',1,
#		'sample',1,
#		'sector',1,
#		'setting',1,
#		'showing',1,
#		'situations',1,
#		'somewhat',1,
#		'steps',1,
#		'submitted',1,
#		'supporting',1,
#		'supports',1,
#		'tag',1,
#		'tool',1,
#		'transmission',1,
#		'van',1,
#		'zeus',1,
#		'accessing',1,
#		'account',1,
#		'accurate',1,
#		'arbitrary',1,
#		'article',1,
#		'asking',1,
#		'assumes',1,
#		'assumption',1,
#		'assumptions',1,
#		'attached',1,
#		'august',1,
#		'authentication',1,
#		'bibliographic',1,
#		'brought',1,
#		'carry',1,
#		'centre',1,
#		'cern',1,
#		'cgi',1,
#		'chapters',1,
#		'chris',1,
#		'commercial',1,
#		'committee',1,
#		'conducted',1,
#		'configured',1,
#		'connect',1,
#		'connolly',1,
#		'construct',1,
#		'constructed',1,
#		'corporation',1,
#		'creates',1,
#		'cruz',1,
#		'customs',1,
#		'cut',1,
#		'danvers',1,
#		'decisions',1,
#		'decode',1,
#		'degree',1,
#		'deployed',1,
#		'develop',1,
#		'discussing',1,
#		'distinct',1,
#		'distribute',1,
#		'ease',1,
#		'effects',1,
#		'efforts',1,
#		'enabling',1,
#		'entities',1,
#		'exists',1,
#		'explain',1,
#		'extensible',1,
#		'extensions',1,
#		'feature',1,
#		'formed',1,
#		'front',1,
#		'gathered',1,
#		'generally',1,
#		'gmt',1,
#		'handles',1,
#		'history',1,
#		'href',1,
#		'iafa',1,
#		'identified',1,
#		'increased',1,
#		'indexing',1,
#		'interaction',1,
#		'interactive',1,
#		'interpretation',1,
#		'introduced',1,
#		'iris',1,
#		'lack',1,
#		'languages',1,
#		'lead',1,
#		'looked',1,
#		'lookup',1,
#		'mars',1,
#		'medium',1,
#		'minor',1,
#		'month',1,
#		'mshapiro',1,
#		'neptune',1,
#		'notice',1,
#		'null',1,
#		'obtained',1,
#		'october',1,
#		'opinions',1,
#		'opportunity',1,
#		'participants',1,
#		'physical',1,
#		'pluto',1,
#		'posted',1,
#		'postscript',1,
#		'procedures',1,
#		'programming',1,
#		'publish',1,
#		'quickly',1,
#		'rating',1,
#		'remain',1,
#		'represented',1,
#		'road',1,
#		'safe',1,
#		'san',1,
#		'santa',1,
#		'saturn',1,
#		'shall',1,
#		'slovenia',1,
#		'sometimes',1,
#		'sources',1,
#		'speed',1,
#		'stages',1,
#		'starts',1,
#		'stop',1,
#		'strategies',1,
#		'subset',1,
#		'success',1,
#		'tei',1,
#		'tend',1,
#		'testing',1,
#		'thor',1,
#		'titan',1,
#		'undertaken',1,
#		'usual',1,
#		'venus',1,
#		'wais',1,
#		'wednesday',1,
#		'act',1,
#		'addr',1,
#		'adoption',1,
#		'aid',1,
#		'alternate',1,
#		'approaches',1,
#		'automated',1,
#		'availability',1,
#		'background',1,
#		'benjamin',1,
#		'bill',1,
#		'bits',1,
#		'btw',1,
#		'cache',1,
#		'cached',1,
#		'caches',1,
#		'charon',1,
#		'clarify',1,
#		'comparative',1,
#		'compared',1,
#		'complexity',1,
#		'consulting',1,
#		'cooperative',1,
#		'coordination',1,
#		'council',1,
#		'criteria',1,
#		'cst',1,
#		'desired',1,
#		'determined',1,
#		'developers',1,
#		'differently',1,
#		'economic',1,
#		'efficient',1,
#		'effort',1,
#		'emerging',1,
#		'entries',1,
#		'evaluation',1,
#		'explained',1,
#		'extensive',1,
#		'familiar',1,
#		'fast',1,
#		'fewer',1,
#		'filtering',1,
#		'firewall',1,
#		'fit',1,
#		'fun',1,
#		'furthermore',1,
#		'gate',1,
#		'gauss',1,
#		'globally',1,
#		'hal',1,
#		'hobbes',1,
#		'holds',1,
#		'hostname',1,
#		'hypertext',1,
#		'ignore',1,
#		'improved',1,
#		'installed',1,
#		'institute',1,
#		'intelligent',1,
#		'interpreting',1,
#		'investigation',1,
#		'jon',1,
#		'jul',1,
#		'keeping',1,
#		'liberte',1,
#		'maa',1,
#		'member',1,
#		'met',1,
#		'million',1,
#		'minimum',1,
#		'nations',1,
#		'operational',1,
#		'originally',1,
#		'outlined',1,
#		'paragraph',1,
#		'passed',1,
#		'password',1,
#		'performance',1,
#		'perth',1,
#		'ports',1,
#		'prior',1,
#		'proceedings',1,
#		'prototype',1,
#		'push',1,
#		'ready',1,
#		'recommend',1,
#		'reduced',1,
#		'req',1,
#		'risk',1,
#		'root',1,
#		'rule',1,
#		'sections',1,
#		'sectors',1,
#		'seek',1,
#		'signed',1,
#		'sound',1,
#		'sponsor',1,
#		'spread',1,
#		'sri',1,
#		'standardization',1,
#		'steel',1,
#		'stored',1,
#		'syntaxes',1,
#		'theoretical',1,
#		'transactions',1,
#		'trouble',1,
#		'typical',1,
#		'unlike',1,
#		'vice',1,
#		'absolute',1,
#		'advanced',1,
#		'affect',1,
#		'anticipated',1,
#		'archive',1,
#		'articles',1,
#		'athena',1,
#		'ave',1,
#		'begin',1,
#		'broken',1,
#		'calvin',1,
#		'champaign',1,
#		'checking',1,
#		'collections',1,
#		'combination',1,
#		'compatibility',1,
#		'composed',1,
#		'concrete',1,
#		'consensus',1,
#		'consultant',1,
#		'conventions',1,
#		'copies',1,
#		'covered',1,
#		'cultural',1,
#		'customer',1,
#		'customers',1,
#		'delivery',1,
#		'derived',1,
#		'editors',1,
#		'education',1,
#		'environments',1,
#		'essential',1,
#		'established',1,
#		'feedback',1,
#		'financial',1,
#		'fixed',1,
#		'fragment',1,
#		'gain',1,
#		'gateways',1,
#		'goals',1,
#		'herr',1,
#		'hold',1,
##		'hoyman',1,
#		'hoymand',1,
#		'huge',1,
#		'ignored',1,
#		'implies',1,
#		'impossible',1,
#		'industries',1,
#		'insensitive',1,
#		'intention',1,
#		'internally',1,
#		'interoperability',1,
#		'inventory',1,
#		'job',1,
#		'jose',1,
#		'karen',1,
#		'layer',1,
#		'leaves',1,
#		'lets',1,
#		'limit',1,
#		'locally',1,
#		'locate',1,
#		'ltd',1,
#		'man',1,
#		'manager',1,
#		'manufacturers',1,
#		'metainformation',1,
#		'microsoft',1,
#		'mostly',1,
#		'nntp',1,
#		'noticed',1,
#		'objective',1,
#		'obvious',1,
#		'obviously',1,
#		'orders',1,
#		'pass',1,
#		'peterd',1,
#		'phoenix',1,
#		'pieces',1,
#		'political',1,
#		'position',1,
#		'possibilities',1,
#		'postal',1,
#		'produce',1,
#		'produced',1,
#		'programme',1,
#		'proposing',1,
#		'reasonably',1,
#		'regard',1,
#		'reported',1,
#		'reports',1,
#		'restrictive',1,
#		'rfcs',1,
#		'scaling',1,
#		'searches',1,
#		'secure',1,
#		'selected',1,
#		'series',1,
#		'shows',1,
#		'simplest',1,
#		'sirius',1,
#		'slash',1,
#		'slow',1,
#		'smaller',1,
#		'springfield',1,
#		'stage',1,
#		'stand',1,
#		'started',1,
#		'students',1,
#		'subscribe',1,
#		'supercomputing',1,
#		'tags',1,
#		'talked',1,
#		'templates',1,
#		'thinkingcat',1,
#		'underlying',1,
#		'universal',1,
#		'warning',1,
#		'welcome',1,
#		'went',1,
#		'white',1,
#		'worlds',1
#		);

sub soif_parse {		# Parse a file with SOIF templates
    return () if (eof($soif_input)); # DW
    local($template_type) = "UNKNOWN";
    local($url) = "UNKNOWN";
    local(%SOIF);
    undef %SOIF;
    local ($attr, $vsize, $value, $end_value);
    
    while (<$soif_input>) {
	last if (/^\@FILE\s*{\s*\S+\s*$/o);
    }
    if (/^\@(\S+)\s*{\s*(\S+)\s*$/o) {
	$template_type = $1, $url = $2;
    } else {
	return ($template_type, $url, %SOIF);	# done
    }

    while (<$soif_input>) {
	if (/^\s*([^{]+){(\d+)}:\t(.*\n)/o) {
	    $attr = $1;
	    $vsize = $2;
	    $value = $3;
	    if (length($value) < $vsize) {
		$nleft = $vsize - length($value);
		$end_value = "";
		$x = read($soif_input, $end_value, $nleft);
		die "Cannot read $nleft bytes: $!" 
		    if ($x != $nleft);
		$value .= $end_value;
		undef $end_value;
	    }
	    chop ($value) if ($value =~ /\n$/);
	    $attr =~ y/a-z/A-Z/;
	    $SOIF{$attr} = $value;
	    undef $value;
	    undef $end_value;
	    next;
	} 
        last if (/^}/o);
    }
    return ($template_type, $url, %SOIF);
}

sub fixstring {
    local($foo) = @_;
    $foo =~ s/[\t\n\r\f\b\a\e ][\t\n\r\f\b\a\e ]*/ /g;
    $foo =~ s/%A//g;
    $foo =~ s/%T//g;
    $foo =~ s/&aring;/\xE5/g;
    $foo =~ s/&Aring/\xC5/g;
    $foo =~ s/&auml;/\xE4/g;
    $foo =~ s/&Auml;/\xC4/g;
    $foo =~ s/&ouml;/\xF6/g;
    $foo =~ s/&Ouml;/\xD6/g;
    $foo =~ s/&eacute;/\xE9/g;
    $foo =~ s/&Eacute;/\xC9/g;
    return ($foo);
}

sub maybeprint {
    local($key,$header) = @_;
    local(@keywords);
    $key =~ y/a-z/A-Z/;
    if (defined $SOIF{$key}) {
	local($value) = &fixstring($SOIF{$key});
	if($header =~ /keywords/) {
	    @keywords = &removewords($value);
	} else {
	    local(@list) = $value =~ split;
	    local($i) = 1;
	    foreach $word (@list) {
		if(length($keywords[$i]) == 0) {
		    $keywords[$i] = $word;
		} else {
		    $keywords[$i] = "$keywords[$i] $word";
		}
		if(length($keywords[$i]) > 200) {
		    $i++;
		    $keywords[$i] = "";
		}
	    }
	}
	foreach $keyword (@keywords) {
	    if(length($keyword) > 0) {
		print " $header: $keyword\n";
	    }
	}
    }
    return(0);
}

sub removewords {
    local($string) = @_;
    local($word);
    local(@list) = $string =~ split;
    local(@strings);
    local($i) = 1;
    $strings[$i] = "";
    foreach $word (@list) {
	if (!defined($commonwords{$word})) {
	    if(length($strings[$i]) == 0) {
		$strings[$i] = $word;
	    } else {
		$strings[$i] = "$strings[$i] $word";
	    }
	    if (length($strings[$i]) > 200) {
		$i++;
		$strings[$i] = "";
	    }
	}
    }
    return(@strings);
}
    
# $soif_input = 'WHATEVER';  # defaults to STDIN
print "% 900 $handle\n";
while(($ttype, $url, %SOIF) = &soif_parse()) {
    next if (%SOIF == ());
    $index = 1;
    while(defined($handles{"$handle$SOIF{'MD5'}$index"})) {
	$index++;
    }
    $handles{"$handle$SOIF{'MD5'}$index"} = 1;
    print "# FULL URC LOCAL $handle$SOIF{'MD5'}$index\n";
    print " URL: $url\n";
    $filename = $url;
    $filename =~ s|^.*/([^/].*)|$1|;
    print " File-Name: $filename\n";

    # First do this once for the outhermost level

    &maybeprint('Nested-Filename','File-Name');
    &maybeprint('Type','File-Format');
    &maybeprint('File-Size','File-Size');
    &maybeprint('MD5','MD5');
    &maybeprint('Description','File-Description');
    &maybeprint('Subject','File-Description');
    &maybeprint('title','File-Title');
    &maybeprint('Author','File-Author');
    &maybeprint('From','File-Author');
    &maybeprint('Date','Date');
    &maybeprint('Organization','Organization-Name');
    &maybeprint('Message-ID','Message-ID');
## Accept keywords if they are on the outher level
    &maybeprint('Keywords','Keywords');

    # Then loop through all embedded files
    $i = 0;
    $found = 1;
    while($found) {
	$i++;
	$found = 0;
	$found |= &maybeprint("Embed<$i>-Nested-Filename",'File-Name');
	if (defined $SOIF{"Embed<$i>-Nested-Filename"} && $SOIF{"Embed<$i>-Nested-Filename"} =~ m|/| ) {
	    $filename = $SOIF{"Embed<$i>-Nested-Filename"};
	    $filename =~ s|^.*/([^/].*)|$1|;
	    print " File-Name: $filename\n";
	}
	$found |= &maybeprint("Embed<$i>-Type",'File-Format');
	$found |= &maybeprint("Embed<$i>-File-Size",'File-Size');
	$found |= &maybeprint("Embed<$i>-MD5",'MD5');
	$found |= &maybeprint("Embed<$i>-Description",'File-Description');
	$found |= &maybeprint("Embed<$i>-Subject",'File-Description');
	$found |= &maybeprint("Embed<$i>-title",'File-Title');
	$found |= &maybeprint("Embed<$i>-Author",'File-Author');
	$found |= &maybeprint("Embed<$i>-From",'File-Author');
	$found |= &maybeprint("Embed<$i>-Date",'Date');
	$found |= &maybeprint("Embed<$i>-Organization",'Organization-Name');
	$found |= &maybeprint("Embed<$i>-Message-ID",'Message-ID');
###
### If you really want keywords in the URC, play with this code
###
#	if (defined $SOIF{"Embed<$i>-Keywords"} ) {
#	    @keywords = &removewords($SOIF{"Embed<$i>-Keywords"});
#	    foreach $keyword (@keywords) {
#		if(length($keyword) > 0) {
#		    print "Keyword: $keyword\n";
#		    $found |= 1;
#		}
#	    }
#	}
    }

    print "# END\n\n";
}
exit(0);
